org.apache.lucene.util.bkd

## Class BKDReader.IndexTree

- java.lang.Object
- - org.apache.lucene.util.bkd.BKDReader.IndexTree

- All Implemented Interfaces:
    Cloneable
  Enclosing class:
    BKDReader

      public abstract class BKDReader.IndexTree
      extends Object
      implements Cloneable

  Used to walk the in-heap index
  NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `level`
    `protected int` | `nodeID`
    `protected int` | `splitDim`
    `protected byte[][]` | `splitPackedValueStack`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `IndexTree()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract BKDReader.IndexTree` | `clone()` Clone, but you are not allowed to pop up past the point where the clone happened.
    `abstract long` | `getLeafBlockFP()` Only valid after pushLeft or pushRight, not pop!
    `int` | `getNodeID()`
    `int` | `getNumLeaves()` Return the number of leaves below the current node.
    `int` | `getSplitDim()` Only valid after pushLeft or pushRight, not pop!
    `abstract BytesRef` | `getSplitDimValue()` Only valid after pushLeft or pushRight, not pop!
    `byte[]` | `getSplitPackedValue()`
    `boolean` | `isLeafNode()`
    `boolean` | `nodeExists()`
    `void` | `pop()`
    `void` | `pushLeft()`
    `void` | `pushRight()`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### nodeID

          protected int nodeID

    - #### level

          protected int level

    - #### splitDim

          protected int splitDim

    - #### splitPackedValueStack

          protected final byte[][] splitPackedValueStack

  - ### Constructor Detail

    - #### IndexTree

          protected IndexTree()

  - ### Method Detail

    - #### pushLeft

          public void pushLeft()

    - #### clone

          public abstract BKDReader.IndexTree clone()

      Clone, but you are not allowed to pop up past the point where the clone happened.
      Overrides:
        `clone` in class `Object`

    - #### pushRight

          public void pushRight()

    - #### pop

          public void pop()

    - #### isLeafNode

          public boolean isLeafNode()

    - #### nodeExists

          public boolean nodeExists()

    - #### getNodeID

          public int getNodeID()

    - #### getSplitPackedValue

          public byte[] getSplitPackedValue()

    - #### getSplitDim

          public int getSplitDim()

      Only valid after pushLeft or pushRight, not pop!

    - #### getSplitDimValue

          public abstract BytesRef getSplitDimValue()

      Only valid after pushLeft or pushRight, not pop!

    - #### getLeafBlockFP

          public abstract long getLeafBlockFP()

      Only valid after pushLeft or pushRight, not pop!

    - #### getNumLeaves

          public int getNumLeaves()

      Return the number of leaves below the current node.

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.